﻿using System;
using System.Collections.Generic;
//using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace WpfTimeConsumingApp
{
    /// <summary>
    /// Window1.xaml の相互作用ロジック
    /// </summary>
    public partial class Window1 : Window
    {
        TimeConsumingJob _job;

        public Window1()
        {
            _job = null;

            InitializeComponent();
            setButtonState();
        }

        private void InterruptButton_Click(object sender, RoutedEventArgs e)
        {
            _job = null;
            setButtonState();
        }

        private void StartButton_Click(object sender, RoutedEventArgs e)
        {
            _job = new TimeConsumingJob();
            this.DataContext = _job;
            _job.Ignission();

            //this.Dispatcher.Invoke(System.Windows.Threading.DispatcherPriority.SystemIdle, new Action<TimeConsumingJob>(this.invokeJob), _job);
            this.Dispatcher.BeginInvoke(System.Windows.Threading.DispatcherPriority.SystemIdle, new Action(this.invokeJob));
            setButtonState();
        }

        private void setButtonState()
        {
            _startButton.IsEnabled     = (null == _job);
            _interruptButton.IsEnabled = !_startButton.IsEnabled;
        }

        void invokeJob()
        {
            if (null == _job)
                return;

            if (!_job.Progress.MoveNext())
            {
                _status.Text = "実行失敗";
            }
            else
            {
                if (_job.Progress.Current >= _job.Maximum)
                {
                    _status.Text = "完了";

                }
                else
                {
                    _status.Text = "実行中";
                    //this.Dispatcher.Invoke(System.Windows.Threading.DispatcherPriority.SystemIdle, new InvokeJobDelegate(this.invokeJob), job);
                    this.Dispatcher.BeginInvoke(System.Windows.Threading.DispatcherPriority.SystemIdle, new Action(this.invokeJob));
                }
            }
        }
    }
}
